Page MenuHomePhabricator

CX2: Allow to switch between CX1 and CX2 from the dashboard
Closed, ResolvedPublic

Description

As part of the transition to Content Translation version 2, there will be a stage where both versions will be available and we want users to be able to easily switch between versions. That would allow users to try the new version as well as go back to the old one if they find something broken in the new one.

We want to support a basic switch that provides:

  • Awareness of the version being used. It should be clear for a translator whether they have the new version enabled or disabled.
  • Understanding that the selection only affects new translations.

Other tickets can complement this with an invite to make users more willing to try the new version or introduction messaging when opening the new version.

Proposed solution

  • A "Try the new version" link is shown in the dashboard sidebar.
    • An icon is used to communicate the experimental nature of the feature. The icon to use is "chem", the one used for chemical formulas, in this case signaling the feature as experimental.
    • Clicking on it, will make CX2 the default for the user. This should be persistent across languages (probably using Global preferences APIs). That is, enabling CX2 should lead the user to the new version even if the user selects a different target language (with the corresponding transition to a different wiki).
  • When the user switches to version 2, a bubble notification will be shown (we should use the standard bubble notification, which may differ in its style with respect to the mockup).
    • The bubble notification will show for 3 seconds the following message: "The new version is enabled. The new editor will be used by default for your new translations. Previous translations will always open with the editor that started them."
  • When version 2 is enabled by default, the "Using the new version" label will be shown instead of the "try the new version" link.
    • An "Disable" action will be provided next to the label. Clicking on it will set the default version to CX1 for the user.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 10 2018, 11:51 AM
Pginer-WMF triaged this task as Normal priority.May 10 2018, 11:51 AM
Pginer-WMF added a project: ContentTranslation.
Pginer-WMF moved this task from Needs Triage to CX2 on the ContentTranslation board.
Vvjjkkii renamed this task from CX2: Allow to switch between CX1 and CX2 from the dashboard to o7caaaaaaa.Jul 1 2018, 1:11 AM
Vvjjkkii raised the priority of this task from Normal to High.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
CommunityTechBot renamed this task from o7caaaaaaa to CX2: Allow to switch between CX1 and CX2 from the dashboard.Jul 2 2018, 5:57 AM
CommunityTechBot lowered the priority of this task from High to Normal.
CommunityTechBot updated the task description. (Show Details)
CommunityTechBot added a subscriber: Aklapper.
Pginer-WMF raised the priority of this task from Normal to High.Sep 3 2018, 11:24 AM
Pginer-WMF updated the task description. (Show Details)Sep 4 2018, 5:21 PM
Pginer-WMF updated the task description. (Show Details)Sep 5 2018, 9:10 AM
Pginer-WMF updated the task description. (Show Details)Sep 6 2018, 11:38 AM
santhosh updated the task description. (Show Details)Sep 10 2018, 5:53 AM

Change 459553 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/extensions/ContentTranslation@master] Allow to switch between CX1 and CX2 from the dashboard

https://gerrit.wikimedia.org/r/459553

@Pginer-WMF I have some design questions.

T194467: Invite to participate in research from the translation dashboard says "The invite will be developed in a way that can be repurposed in the future. The idea is to use a similar invite to encourage users to try the version 2 of Content Translation when it is ready for a wider exposure".
This ticket was created around the same time as T194467. Did you change design decision on purpose?

I see some problems with adding button for version switching in place where help links are positioned. The button is out of context. In addition to button-vs-link context, the title of the card says "Need help translating?", making it clear that it displays help links.

Invitation widget has the advantage of being more prominent, we have more space for longer translations and it's not inside a wrong context like the link inside the help card. On the other side, it would need to be always displayed to let the users know they are using the new version. But it occupies too much space and breaks the flow.

I published the WIP patch which implements the UI the way described in this ticket. I have changed what used to be links into OOUI frameless buttons with standard icons. There are some visual differences which can be seen on the screenshots below. When hovered, links are underlined, while button changes opacity. Also, focus color is different for OOUI buttons, but pressing Return key actually visits the URL.

Current stateProposed new stateProposed new state (toggled)

@Pginer-WMF I have some design questions.

Thanks for sharing your thoughts, @Petar.petkovic. Some replies below.

T194467: Invite to participate in research from the translation dashboard says "The invite will be developed in a way that can be repurposed in the future. The idea is to use a similar invite to encourage users to try the version 2 of Content Translation when it is ready for a wider exposure".
This ticket was created around the same time as T194467. Did you change design decision on purpose?

The general idea is to expose the new version gradually, for which we plan different interventions, moving from one step to the next based on feedback (i.e., checking how well the tool works for a number of users before expanding such group). The stages are:

  • Access v2 using a URL parameter (done)
  • Access v2 with a switch you can turn on and off (this ticket)
  • Show an invite that encourages users to try the new version (ticket to be created). This allows a one-click enablement of v2, which relies on the previous switch to allow going back to v1.

I see some problems with adding button for version switching in place where help links are positioned. The button is out of context. In addition to button-vs-link context, the title of the card says "Need help translating?", making it clear that it displays help links.

The area labelled as "Need help translating?" is where we provide different kinds of help. The new version is provided as a way to get all the improved features it brings. It may not be exactly the same as the other items in the group, but I don't consider it completely out of place either.

Invitation widget has the advantage of being more prominent, we have more space for longer translations and it's not inside a wrong context like the link inside the help card. On the other side, it would need to be always displayed to let the users know they are using the new version. But it occupies too much space and breaks the flow.

As mentioned above, they are complementing each other. A permanent switch and a more prominent invite.

I published the WIP patch which implements the UI the way described in this ticket. I have changed what used to be links into OOUI frameless buttons with standard icons. There are some visual differences which can be seen on the screenshots below. When hovered, links are underlined, while button changes opacity. Also, focus color is different for OOUI buttons, but pressing Return key actually visits the URL.

Current stateProposed new stateProposed new state (toggled)

Looks good to me.

Change 459803 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/extensions/ContentTranslation@master] Allow to switch between CX1 and CX2 from the dashboard

https://gerrit.wikimedia.org/r/459803

Petar.petkovic added a comment.EditedSep 11 2018, 3:21 PM
In the ticket description, @Pginer-WMF wrote:

The bubble notification will show for 3 seconds

This is not configurable in Mediawiki notifications. Options are short (5 sec) and long (30 sec).
So, duration will need to be five seconds, instead of three.

In the ticket description, @Pginer-WMF wrote:

The bubble notification will show for 3 seconds

This is not configurable in Mediawiki notifications. Options are short (5 sec) and long (30 sec).
So, duration will need to be five seconds, instead of three.

5 seconds seems good.

While reviewing I noticed that this patch used "previous translation" while there are some messages that refer to the same thing as "draft". Do we want to update those messages, as we now also have the possibility to publish as a draft, and using draft for two things can be confusing?

While reviewing I noticed that this patch used "previous translation" while there are some messages that refer to the same thing as "draft". Do we want to update those messages, as we now also have the possibility to publish as a draft, and using draft for two things can be confusing?

We should avoid the use fo the term "draft" to refer to in-progress translations. If you can provide more information on the messages with potentially incorrect use, we can create a ticket to change them.

Change 459803 merged by jenkins-bot:
[mediawiki/extensions/ContentTranslation@master] Allow to switch between CX1 and CX2 from the dashboard

https://gerrit.wikimedia.org/r/459803

Etonkovidova closed this task as Resolved.Sep 20 2018, 1:02 AM
Etonkovidova added a subscriber: Etonkovidova.

Checked in testwiki and cawiki (wmf.22) - works as expected (checked in IE/Edge Windows also).

@Pginer-WMF 5sec for displaying the popup with 28 words seems to be rather short. Average reading speed (at least in English) is 200 words per min, so the reading time for the popup should at least more than 8sec.

Petar.petkovic removed a subscriber: gerritbot.
Pginer-WMF reopened this task as Open.Sep 20 2018, 8:25 AM

A couple of adjustments are still needed:

  • Adjust bubble notification time to be long (30 sec). The time to read the message seems a bit tight, as @Etonkovidova pointed.
  • After activating v2, when it is loaded in another wiki, the message is wrong. Currently it is "Try the new feature" where it should be "Using the new version" instead:

The patch to fix points @Pginer-WMF made in T194387#4600728 is merged now. Moving back to QA for confirmation.

Etonkovidova closed this task as Resolved.Sep 21 2018, 12:45 AM

Checked the fix for both @Pginer-WMF suggestions above.

Checked the fix for both @Pginer-WMF suggestions above.

What @Pginer-WMF reported was the problem of user enabling CX2 via the switcher, and after reloading the page or opening the CX dashboard in another wiki, the message said "Try the new version", even though the user is already trying the new version.

Second thing was the duration of bubble notification.

Not sure what you wanted to say with circling the ULS link in the personal bar at the top, but I'll move this to Done.